/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Contents of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.38 - (show annotations) (download)
Wed Nov 1 14:32:22 2006 UTC (7 years, 8 months ago) by zzam
Branch: MAIN
Changes since 1.37: +4 -3 lines
Add LDFLAGS to link-commands not yet containing it.

1 # Copyright 1999-2005 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/vdr-plugin.eclass,v 1.37 2006/10/19 10:26:10 zzam Exp $
4 #
5 # Author:
6 # Matthias Schwarzott <zzam@gentoo.org>
7 # Joerg Bornkessel <hd_brummy@gentoo.org>
8
9 # vdr-plugin.eclass
10 #
11 # eclass to create ebuilds for vdr plugins
12 #
13
14 # Example ebuild (vdr-femon):
15 #
16 # inherit vdr-plugin
17 # IUSE=""
18 # SLOT="0"
19 # DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)"
20 # HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/"
21 # SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz"
22 # LICENSE="GPL-2"
23 # KEYWORDS="~x86"
24 # DEPEND=">=media-video/vdr-1.3.27"
25 #
26 #
27
28 # Installation of a config file for the plugin
29 #
30 # If ${VDR_CONFD_FILE} is set install this file
31 # else install ${FILESDIR}/confd if it exists.
32
33 # Gets installed as /etc/conf.d/vdr.${VDRPLUGIN}.
34 # For the plugin vdr-femon this would be /etc/conf.d/vdr.femon
35
36
37 # Installation of an rc-addon file for the plugin
38 #
39 # If ${VDR_RCADDON_FILE} is set install this file
40 # else install ${FILESDIR}/rc-addon.sh if it exists.
41 #
42 # Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
43 # (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
44 #
45 # This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
46 # It could be used for special startup actions for this plugins, or to create the
47 # plugin command line options from a nicer version of a conf.d file.
48
49 # HowTo use own local patches; Example
50 #
51 # Add to your /etc/make.conf:
52 # VDR_LOCAL_PATCHES_DIR="/usr/local/patch"
53 #
54 # Add two DIR's in your local patch dir, ${PN}/${PV},
55 # e.g for vdr-burn-0.1.0 should be:
56 # /usr/local/patch/vdr-burn/0.1.0/
57 #
58 # all patches which ending on diff or patch in this DIR will automatically applied
59 #
60
61 inherit base multilib eutils flag-o-matic
62
63 IUSE="debug"
64
65 # Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66 VDRPLUGIN="${PN/#vdrplugin-/}"
67 VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
68 VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
69
70 DESCRIPTION="vdr Plugin: ${VDRPLUGIN} (based on vdr-plugin.eclass)"
71
72 # works in most cases
73 S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74
75 # depend on headers for DVB-driver
76 RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1"
77 DEPEND="media-tv/linuxtv-dvb-headers"
78
79
80 # this code is from linux-mod.eclass
81 update_vdrplugindb() {
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
83
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR}
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92 }
93
94 remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi
101 }
102
103 # New method of storing plugindb
104 # Called from src_install
105 # file maintained by normal portage-methods
106 create_plugindb_file() {
107 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
108 local DB_FILE=${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}
109 insinto ${NEW_VDRPLUGINDB_DIR}
110 cat <<-EOT > ${D}/${DB_FILE}
111 VDRPLUGIN_DB=1
112 CREATOR=ECLASS
113 EBUILD=${CATEGORY}/${PN}
114 EBUILD_V=${PVR}
115 EOT
116 }
117
118 # Delete files created outside of vdr-plugin.eclass
119 # vdrplugin-rebuild.ebuild converted plugindb and files are
120 # not deleted by portage itself - should only be needed as
121 # long as not every system has switched over to
122 # vdrplugin-rebuild-0.2
123 delete_orphan_plugindb_file() {
124 #einfo Testing for orphaned plugindb file
125 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
126 local DB_FILE=${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}
127
128 # file exists
129 [[ -f ${DB_FILE} ]] || return
130
131 # will portage handle the file itself
132 if grep -q CREATOR=ECLASS ${DB_FILE}; then
133 #einfo file owned by eclass - don't touch it
134 return
135 fi
136
137 einfo "Removing orphaned plugindb-file."
138 einfo "#rm ${DB_FILE}"
139 rm ${DB_FILE}
140 }
141
142 vdr-plugin_pkg_setup() {
143 # -fPIC is needed for shared objects on some platforms (amd64 and others)
144 append-flags -fPIC
145 use debug && append-flags -g
146
147 # Where should the plugins live in the filesystem
148 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
149 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
150
151 # was /usr/lib/... some time ago
152 # since gentoo-vdr-scripts-0.3.6 it works with /usr/share/...
153 VDR_RC_DIR="/usr/share/vdr/rcscript"
154
155 # Pathes to includes
156 VDR_INCLUDE_DIR="/usr/include/vdr"
157 DVB_INCLUDE_DIR="/usr/include"
158
159
160 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
161 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
162 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
163
164 einfo "Building ${PF} against vdr-${VDRVERSION}"
165 einfo "APIVERSION: ${APIVERSION}"
166 }
167
168 vdr-plugin_src_unpack() {
169 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
170 eerror "Wrong use of vdr-plugin.eclass."
171 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
172 echo
173 eerror "Please report this at bugs.gentoo.org."
174 die "vdr-plugin_pkg_setup not called!"
175 fi
176 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile
177
178 while [ "$1" ]; do
179
180 case "$1" in
181 all_but_unpack)
182 vdr-plugin_src_unpack add_local_patch patchmakefile
183 ;;
184 unpack)
185 base_src_unpack
186 ;;
187 patchmakefile)
188 if ! cd ${S}; then
189 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
190 ewarn "Perhaps you find one among these:"
191 cd "${WORKDIR}"
192 einfo "$(/bin/ls -1 ${WORKDIR})"
193 die "Could not change to plugin-source-directory!"
194 fi
195
196 einfo "Patching Makefile"
197 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
198 cp Makefile Makefile.orig
199
200 sed -i Makefile \
201 -e '1i\#Makefile was patched by vdr-plugin.eclass'
202
203 ebegin " Setting Pathes"
204 sed -i Makefile \
205 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
206 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
207 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
208 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
209 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
210 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
211 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
212 eend $?
213
214 ebegin " Converting to APIVERSION"
215 sed -i Makefile \
216 -e 's:^APIVERSION = :APIVERSION ?= :' \
217 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
218 -e '2i\APIVERSION = '"${APIVERSION}"
219 eend $?
220
221 ebegin " Correcting Compile-Flags"
222 sed -i Makefile \
223 -e 's:^CXXFLAGS:#CXXFLAGS:' \
224 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
225 eend $?
226
227 ebegin " Disabling file stripping"
228 sed -i Makefile \
229 -e '/@.*strip/d' \
230 -e '/strip \$(LIBDIR)\/\$@/d' \
231 -e '/^STRIP =/d' \
232 -e '/@.*\$(STRIP)/d'
233 eend $?
234
235 # Use a file instead of an variable as single-stepping via ebuild
236 # destroys environment.
237 touch ${WORKDIR}/.vdr-plugin_makefile_patched
238 ;;
239 add_local_patch)
240 cd ${S}
241 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
242 echo
243 einfo "Applying local patches"
244 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
245 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
246 done
247 fi
248 ;;
249 esac
250
251 shift
252 done
253 }
254
255 vdr-plugin_copy_source_tree() {
256 pushd . >/dev/null
257 cp -r ${S} ${T}/source-tree
258 cd ${T}/source-tree
259 mv Makefile.orig Makefile
260 sed -i Makefile \
261 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
262 -e 's:^CXXFLAGS:#CXXFLAGS:' \
263 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
264 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
265 popd >/dev/null
266 }
267
268 vdr-plugin_install_source_tree() {
269 einfo "Installing sources"
270 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
271 insinto ${destdir}-${PV}
272 doins -r ${T}/source-tree/*
273
274 dosym ${VDRPLUGIN}-${PV} ${destdir}
275 }
276
277 vdr-plugin_src_compile() {
278 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
279
280 while [ "$1" ]; do
281
282 case "$1" in
283 prepare)
284 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
285 ;;
286 compile)
287 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
288 eerror "Wrong use of vdr-plugin.eclass."
289 eerror "An ebuild for a vdr-plugin will not work without"
290 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
291 echo
292 eerror "Please report this at bugs.gentoo.org."
293 die "vdr-plugin_src_unpack not called!"
294 fi
295 cd ${S}
296
297 emake ${BUILD_PARAMS} ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed"
298 ;;
299 esac
300
301 shift
302 done
303 }
304
305 vdr-plugin_src_install() {
306 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
307 cd ${S}
308
309 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
310 local mname=${P}-Makefile
311 cp Makefile ${mname}.patched
312 cp Makefile.orig ${mname}.before
313
314 diff -u ${mname}.before ${mname}.patched > ${mname}.diff
315
316 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
317 doins ${mname}.diff
318
319 insinto "/usr/share/vdr/maintainer-data/makefile-before"
320 doins ${mname}.before
321
322 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
323 doins ${mname}.patched
324
325 fi
326
327 insinto "${VDR_PLUGIN_DIR}"
328 doins libvdr-*.so.*
329 local docfile
330 for docfile in README* HISTORY CHANGELOG; do
331 [[ -f ${docfile} ]] && dodoc ${docfile}
332 done
333
334 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
335 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
336
337 if [[ -n ${VDR_CONFD_FILE} ]]; then
338 insinto /etc/conf.d
339 newins "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
340 fi
341
342
343 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
344 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
345
346 if [[ -n ${VDR_RCADDON_FILE} ]]; then
347 insinto "${VDR_RC_DIR}"
348 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
349 fi
350
351
352
353 insinto ${VDR_CHECKSUM_DIR}
354 if [[ -f ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
355 newins ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}
356 else
357 if which md5sum >/dev/null 2>&1; then
358 cd ${S}
359 (
360 cd ${ROOT}${VDR_INCLUDE_DIR}
361 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
362 ) > header-md5-${PN}
363 doins header-md5-${PN}
364 fi
365 fi
366
367 create_plugindb_file
368 }
369
370 vdr-plugin_pkg_postinst() {
371 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
372 update_vdrplugindb
373 fi
374 einfo
375 einfo "The vdr plugin ${VDRPLUGIN} has now been installed."
376 einfo "To activate execute the following command:"
377 einfo
378 einfo " emerge --config ${PN}"
379 einfo
380 if [[ -n "${VDR_CONFD_FILE}" ]]; then
381 einfo "And have a look at the config-file"
382 einfo "/etc/conf.d/vdr.${VDRPLUGIN}"
383 einfo
384 fi
385 }
386
387 vdr-plugin_pkg_postrm() {
388 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
389 remove_vdrplugindb
390 fi
391 delete_orphan_plugindb_file
392 }
393
394 vdr-plugin_pkg_config_final() {
395 diff ${conf_orig} ${conf}
396 rm ${conf_orig}
397 }
398
399 vdr-plugin_pkg_config_old() {
400 einfo "Using interface of gentoo-vdr-scripts-0.3.6 and older"
401 if [[ -z "${INSTALLPLUGIN}" ]]; then
402 INSTALLPLUGIN="${VDRPLUGIN}"
403 fi
404 # First test if plugin is already inside PLUGINS
405 local conf=/etc/conf.d/vdr
406 conf_orig=${conf}.before_emerge_config
407 cp ${conf} ${conf_orig}
408
409 einfo "Reading ${conf}"
410 if ! grep -q "^PLUGINS=" ${conf}; then
411 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
412 if [[ -n "${LINE}" ]]; then
413 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
414 else
415 echo 'PLUGINS=""' >> ${conf}
416 fi
417 unset LINE
418 fi
419
420 unset PLUGINS
421 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
422
423 active=0
424 for p in ${PLUGINS}; do
425 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
426 active=1
427 break;
428 fi
429 done
430
431 if [[ "${active}" == "1" ]]; then
432 einfo "${INSTALLPLUGIN} already activated"
433 echo
434 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
435 if [[ "${answer}" != "yes" ]]; then
436 einfo "aborted"
437 return
438 fi
439 einfo "Removing ${INSTALLPLUGIN} from active plugins."
440 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
441 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
442 -e ${LINE}'s/ \( \)*/ /g' \
443 -e ${LINE}'s/ "/"/g' \
444 -e ${LINE}'s/" /"/g'
445
446 vdr-plugin_pkg_config_final
447 return
448 fi
449
450
451 einfo "Adding ${INSTALLPLUGIN} to active plugins."
452 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
453 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
454 -e ${LINE}'s/ \( \)*/ /g' \
455 -e ${LINE}'s/ "/"/g' \
456 -e ${LINE}'s/" /"/g'
457
458 vdr-plugin_pkg_config_final
459 }
460
461 vdr-plugin_pkg_config_new() {
462 einfo "Using interface introduced with gentoo-vdr-scripts-0.3.7"
463 if [[ -z "${INSTALLPLUGIN}" ]]; then
464 INSTALLPLUGIN="${VDRPLUGIN}"
465 fi
466
467 active=0
468 # First test if plugin is already inside PLUGINS
469 local conf=/etc/conf.d/vdr.plugins
470 exec 3<${conf}
471 while read -u 3 line; do
472 [[ ${line} == "" ]] && continue
473 [[ ${line:0:1} == "#" ]] && continue
474 set -- ${line}
475 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
476 done
477 exec 3<&-
478
479 if [[ $active == 0 ]]; then
480 einfo "Adding ${INSTALLPLUGIN} to active plugins."
481
482 # The pure edit process.
483 echo "${INSTALLPLUGIN}" >> "${conf}"
484 else
485 einfo "${INSTALLPLUGIN} already activated"
486 echo
487 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
488 if [[ "${answer}" != "yes" ]]; then
489 einfo "aborted"
490 return
491 fi
492 einfo "Removing ${INSTALLPLUGIN} from active plugins."
493
494 # The pure edit process
495 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
496 fi
497 }
498
499 vdr-plugin_pkg_config() {
500 if has_version ">media-tv/gentoo-vdr-scripts-0.3.6"; then
501 vdr-plugin_pkg_config_new
502 else
503 vdr-plugin_pkg_config_old
504 fi
505 }
506
507 fix_vdr_libsi_include()
508 {
509 einfo "Fixing include of libsi-headers"
510 local f
511 for f; do
512 sed -i "${f}" \
513 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
514 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
515 done
516 }
517
518 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config

  ViewVC Help
Powered by ViewVC 1.1.20